# Cpp_WarCardGame

First of all I defined MAX_CARDS = 13 constant, wihch is max cards set by you per player. As far as I see, suit does’nt matter for outcome of game. 

I used structs for players and cards deck, since suit does’nt really matter, althgough it has been mentioned in project assignment.

First I defined structs for Card and Player.

Next, follows a function declaration statements.

I initialized core variables of the game, which is: 
    int numberOfPlayers;
    int roundNumber = 1;
    int gameWinner;
    int roundRollOverScore = 0;
    int rollOverTrue = 0;
    int thisRoundScore = 0;
    char keyContinue;

I didn’t use load or save features in the game. Game starts from user choosing amount of players.

After every round and player choice, console is cleared using: “system("@cls||clear");”

I’ve created created arrays of struct for Player and Card for each player, using number of players value, which is entered by user at the start of the game.

Faces and Values of the card’s are hardcoded in single arrray[13].

Using createPlayersDecks(...) fuction I created individual decks for each player.

As game requires, total number of player’s scores, using a funciotn initilizePlayerScores(), I set player score values to 0 for correct functioning.

Next follows a while loop with goto identifier for roll over round scores.
In a round while loop:

	for loop to display and make choices of a individual player,
	while, always adding values of their choices to roundCardValueArr[].

Next, follows char enter command with a purpose of viewing player choice and clearing console after pressing any key(ENTER prefered).

RollOverTrue vriable is initialiezed to 11 if round scores is rolled over.

If variable rollOverTrue = 11, game enters roll over if statement which sets  roundRollOverScore = to current roundScore.
It prints info of a current roll over round and using goto(which is bad practice elsewhere) points to next round, which means next iterattion of while loop.

Else if round isn’t rolled’ed we print out usual information of round like:
	total score;
	winner of round;
	and such;
	In case of this, rondRollOverScore is set to 0.

At the end of while loop, which represents rounds, we increase roundNumber by 1. Only other place its being icreased, is at rolll over if statetment if round is rolled over.
	If round is rolled over ,I used goto(which is, as far as i know, a bad practice) statement to go to the start of the loop and start next round, also updateing roundNumber variable.
	Else if round is not all card tie, we continue with normal progresssion of rounds and print info of winning player, round total score and print the winner of the round info on screen.
	Also I set roundRollOverScore to 0, to keep roll over rounds on correct count,

After I exit while loop(represeinting rounds),  I use a funcrion to determine an index of a game winner using findGameWinner() function,

After a winner is clear, I print game ending title, and winning player name and score.

There is a function initilizePlayerScores() used to initialiaze player scores to 0 for correct calculations of total score.44

creaetPlayerDecks() function is used to create decks of individual players.

FindGameWinner() is used to determine a winner of fully finneshed game, and returns an index of a winning player.

ShowPlayerCards is a fucnction, which, does exactly what it says, displays current player cards.

PlaeyerPickCard() function allows each player to pick a card, and returns its value.

RoundScore() function takes a roundCardValueArr as a formal parameter and uses it to calculate the total round score, which is returned by same function.

RoundWinner() function is the most interesting of all.
Frst of all, I initialize tieCarrds array values to 0 for correct functionuing of array.

I use complicated for loop to check if any cards tie, if so their values are set to 1.

Even so, it could be placed in other place, next I check if all player’s cards tie and if round should be rolled over. 
For, which, I call function  checkIfAllCardsTie(), if it returns 0, I continue  with round winner calculations. Which, includes, determening the winner of the round yb using for loop.
 
Else a allTie value is returend which puts all players into rollover round, and carries score to the next round.




